unit ugrep;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, SDL_stringl;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MMResult: TMemo;
    Panel1: TPanel;
    BButExit: TBitBtn;
    Label1: TLabel;
    EdRegexp: TEdit;
    CBIgnoreCase: TCheckBox;
    BButStartSearch: TBitBtn;
    Bevel1: TBevel;
    Grep1: TGrep;
    procedure CBIgnoreCaseClick(Sender: TObject);
    procedure BButExitClick(Sender: TObject);
    procedure BButStartSearchClick(Sender: TObject);
  private
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(*************************************************************)
procedure TForm1.BButStartSearchClick(Sender: TObject);
(*************************************************************)

var
  Infile : TextFile;
  astr   : string;
  ix     : integer;
  linecnt: longint;

begin
Grep1.RegExp := EdRegExp.Text;
MMResult.Clear;
OpenDialog1.Filename := '*.txt';
if OpenDialog1.Execute then
  begin
  assignFile (InFile, OpenDialog1.Filename);
  reset (Infile);
  linecnt := 0;
  MMResult.Visible := false;
  while not eof(InFile) do
    begin
    readln (Infile, astr);
    inc(linecnt);
    if Grep1.MatchString (astr, ix) then
      begin
      MMResult.Lines.Add (LeftString(IntToStr(linecnt),3)+RightString(' ['+IntToStr(Grep1.MatchStartPos)+'-'+IntToStr(Grep1.MatchEndPos),8)+']: '+astr);
      end;
    end;
  MMResult.Visible := true;
  closeFile (Infile);
  end;
end;


(*************************************************************)
procedure TForm1.CBIgnoreCaseClick(Sender: TObject);
(*************************************************************)

begin
if CBIgnoreCase.Checked
  then Grep1.IgnoreCase := true
  else Grep1.IgnoreCase := false;
end;

(*************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(*************************************************************)

begin
close;
end;

end.
